#include <Adafruit_CircuitPlayground.h>
#include <string>


// Template ID, Device Name and Auth Token are provided by the Blynk.Cloud
// See the Device Info tab, or Template settings
#define BLYNK_TEMPLATE_ID "TMPL-493TiK1"
#define BLYNK_DEVICE_NAME "My Tasks"
#define BLYNK_AUTH_TOKEN "LKfSbaZy3Pu8IrdlX1B6Zf6ZwiKz9lOc"


// Comment this out to disable prints and save space
#define BLYNK_PRINT SerialUSB
#define BLYNK_PRINT Serial

#include <Wire.h>
#include <SPI.h>
#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>

char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "BeSpotF0A7_2.4";
char pass[] = "8B00F0A7";

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

int ledValues[10][3] = {0};
bool doNotDisturb = false;
int led = 0;
int taskFinished;

void reorganizeLeds() {
  for (int i = taskFinished; i < led; i++) {
    delay(2000);
    ledValues[i][0] = ledValues[i + 1][0];
    ledValues[i][1] = ledValues[i + 1][1];
    ledValues[i][2] = ledValues[i + 1][2];
    CircuitPlayground.setPixelColor(i, ledValues[i][0], ledValues[i][1], ledValues[i][2]);
  }
}

// pick task number
BLYNK_WRITE(V1)
{
  taskFinished = param.asInt();
  ledValues[taskFinished][0] = 0;
  ledValues[taskFinished][1] = 0;
  ledValues[taskFinished][2] = 0;
  CircuitPlayground.setPixelColor(taskFinished, 0, 0, 0);
  if (taskFinished != led - 1) {
    reorganizeLeds();
    led--;
  }
}

void notifyWithSound(int urgency, double freq, int length) {
  for (int i = 0; i < urgency; i++) {
    CircuitPlayground.playTone(freq, length);
  }
}

void checkForDoNotDisturb() {
  if (CircuitPlayground.lightSensor() < 30) {
    doNotDisturb = true;
  }
  else {
    doNotDisturb = false;
  }
}

void updateNewLed(int r, int g, int b) {
  ledValues[led][0] = r;
  ledValues[led][1] = g;
  ledValues[led][2] = b;
  CircuitPlayground.setPixelColor(led, r, g, b);
  led++;
}

// New Task mail was sent
BLYNK_WRITE(V0) {
  int urgency = param.asInt(); 
  checkForDoNotDisturb();

  // pink
  if (urgency == 1) { 
    updateNewLed(255, 192, 203);
    if (!doNotDisturb) {
      notifyWithSound(urgency, 261.63, 400);
    }
  }
  // yellow
  else if (urgency == 2) {
    updateNewLed(255, 255, 0);
    if (!doNotDisturb) {
      notifyWithSound(urgency, 293.66, 300);
    }    
  }
  // green
  else if (urgency == 3) {
    updateNewLed(0, 255, 0);
    if (!doNotDisturb) {
      notifyWithSound(urgency, 329.63, 200);
    }    
  }
  // blue
  else if (urgency == 4) {
    updateNewLed(0, 0, 255);
    if (!doNotDisturb) {
      notifyWithSound(urgency, 349.23, 150);
    }    
  }
  // red
  else if (urgency == 5) {
    updateNewLed(255, 0, 0);
    if (!doNotDisturb) {
      notifyWithSound(urgency, 392.00, 100);
    }    
  }
}

void setup() {
  // put your setup code here, to run once:
  SerialUSB.begin(115200);
  CircuitPlayground.begin();
  
  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);

  Blynk.begin(auth, wifi, ssid, pass);
}

void loop() {
  // put your main code here, to run repeatedly:
  Blynk.run();
}
